sub generate-id() {
    ('0' ... '9', 'a' ... 'z').pick(8).join
}

class Ramini::Logger {
    has Str $!id is built;

    method new() {
        self.bless(id => generate-id())
    }

    method log(Str:D $msg) {
        say "[" ~ $!id ~ "] " ~ $msg;
    }

    method exception(Exception $e) {
        self.log("ERROR: " ~ $e.Str);
        for $e.backtrace.reverse {
            next if .file.starts-with('SETTING::');
            next unless .subname;
            self.log("  | in block {.subname} at {.file} line {.line}");
        }
    }
}
